using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace encinsp
{
    public static class ID3v1
    {
        private const int TagSize = 128;

        /// <summary>
        /// Returns the size of a BinaryReader's ID3v1 tag (0 or 128)
        /// </summary>
        /// <param name="br">Open BinaryReader</param>
        /// <returns>Size of ID3v1 Tag (0 or 128)</returns>
        public static Int32 GetTagSize(BinaryReader br)
        {
            br.BaseStream.Seek(-TagSize, SeekOrigin.End);
            if (System.Text.Encoding.ASCII.GetString(br.ReadBytes(3)) == "TAG")
            {
                return TagSize;
            }
            else
            {
                return 0;
            }
        }
    }
}
