using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace encinsp
{
    public static class ID3v2
    {
        /// <summary>
        /// Returns the size of a BinaryReader's ID3v2 tag
        /// </summary>
        /// <param name="br">Open BinaryReader</param>
        /// <returns>Size of ID3v2 Tag</returns>
        public static Int32 GetTagSize(BinaryReader br)
        {
            br.BaseStream.Seek(0, SeekOrigin.Begin);

            Int32 startPos = 0;

            if (System.Text.Encoding.ASCII.GetString(br.ReadBytes(3)) == "ID3")
            {
                br.BaseStream.Seek(6, SeekOrigin.Begin);

                startPos = 10;
                startPos += br.ReadByte() << (24 - 3);
                startPos += br.ReadByte() << (16 - 2);
                startPos += br.ReadByte() << (8 - 1);
                startPos += br.ReadByte();
            }

            return startPos;
        }
    }
}
